/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jpctsample;

import com.threed.jpct.*;
import java.util.Random;
import javax.swing.JFrame;

public class IsoWorld {

	private World world;
	private FrameBuffer buffer;

	private JFrame frame;

	public static void main(String[] args) throws Exception {
		new IsoWorld().loop();
	}

	public IsoWorld() throws Exception {
            Config.maxPolysVisible = 16387;
            Config.saveMemory = true;

            frame=new JFrame("Hello world");
		frame.setSize(640, 480);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		world = new World();
		world.setAmbientLight(127, 127, 127);
            int light = world.addLight(new SimpleVector(50, 50, -40), new java.awt.Color(255, 255, 255, 127));
            world.setLightIntensity(light, 40.f, 40.f, 40.f);

                
            Object3D[] objects = Loader.load3DS("pesanthouse.3ds", 0.03f);
            for (int i=0; i<9; ++i) {
                for (int j=0; j<9; ++j) {
                    for (Object3D o2 : objects) {
                        Object3D o = o2.cloneObject();
                        o.translate(i*7.f, j*7.f, 0.f);
                        world.addObject(o);
                        System.out.println("memory used: "+((Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory())/1024/1024)+"MB.");
                    }
                }
            }
                
		world.getCamera().setPosition(20, 20, -40);
                world.getCamera().rotateCameraX( - (float)Math.PI / 8.f);
	}

      long counter = 0;
      long counterThreshold = 600;
      long timestart = 0;

	private void loop() throws Exception {
		buffer = new FrameBuffer(640, 480, FrameBuffer.SAMPLINGMODE_NORMAL);
		buffer.disableRenderer(IRenderer.RENDERER_SOFTWARE);
		buffer.enableRenderer(IRenderer.RENDERER_OPENGL);
                
           timestart = System.currentTimeMillis();
		while (frame.isShowing()) {
                  buffer.clear(java.awt.Color.BLUE);
			world.renderScene(buffer);
			world.draw(buffer);
			buffer.update();
                  buffer.display(frame.getGraphics());
                  if (counter >= counterThreshold) {
                      System.out.println("average rendering time = "+((System.currentTimeMillis() - timestart) / counterThreshold)+"ms");
                      counter = 0;
                      timestart = System.currentTimeMillis();
                  }
                  else {
                     counter++;
                     world.getCamera().moveCamera(new SimpleVector(1.f, 0.f, 0.f), 0.002f);
                  }
                  //Thread.sleep(10);
		}
		buffer.disableRenderer(IRenderer.RENDERER_OPENGL);
		buffer.dispose();
		frame.dispose();
		System.exit(0);
	}
    
    
}
